{%- from "shuup/front/macros/general.jinja" import render_supplier_info -%}
{%- from "shuup_definite_theme/macros/basket.jinja" import render_basket_supplier_info -%}

{% macro service_panel(panel_title, method_title, address_title, method, address) %}
    <h2 class="h3 mt-6 mb-3">{{ panel_title }}</h2>
    <dl>
        <dt>{{ method_title }}</dt>
        <dd>{% if method %}{{ method.name }}{% else %}{{ _("No method selected") }}{% endif %}</dd>
        {% if address %}
            <dt class="mt-2">{{ address_title }}</dt>
            <dd>{{ format_address(address) }}</dd>
        {% endif %}
    </dl>
{% endmacro %}

{% macro render_company_information(order) %}
    {% if order.company %}
        <h2 class="h3 mt-6 mb-3">{% trans %}Company{% endtrans %}</h2>
        <p>{{ order.company.name }} ({% trans %}Tax number{% endtrans %}: {{ order.company.tax_number }})</p>
    {% endif %}
{% endmacro %}

{% macro render_tax_information(order) %}
    <h2 class="h3 mt-6 mb-3">{% trans %}Tax breakdown{% endtrans %}</h2>
    <div class="table-responsive">
        {{ render_taxes_table(order) }}
    </div>
{% endmacro %}

{% macro render_lines_information(order) %}
    <h2 class="h3 mt-6 mb-3">{% trans %}Products ordered{% endtrans %}</h2>
    {% set lines = order.lines.order_by("ordering") %}
    {{ render_lines_table(lines, order.taxful_total_price, order.taxless_total_price) }}
{% endmacro %}

{% macro render_shipping_address(order, column_class="col-sm-6") %}
    <div class="{{ column_class }}">
        {{ service_panel(_("Delivery"), _("Delivery method"), _("Shipping address"), order.shipping_method, order.shipping_address) }}
    </div>
{% endmacro %}

{% macro render_billing_address(order, column_class="col-sm-6") %}
    <div class="{{ column_class }}">
        {{ service_panel( _("Billing"), _("Payment method"), _("Billing address"), order.payment_method, order.billing_address) }}
    </div>
{% endmacro %}

{% macro render_service_information(order) %}
    <div class="row">
        {% if order.shipping_address and order.billing_address %}
            {{ render_shipping_address(order) }}
            {{ render_billing_address(order) }}
        {% elif order.billing_address %}
            {{ render_billing_address(order, "col-sm-12") }}
        {% elif order.shipping_address %}
            {{ render_shipping_address(order, "col-sm-12") }}
        {% endif %}
    </div>
{% endmacro %}

{% macro render_ordered_files(order) %}
    {% set attachments = order.get_purchased_attachments() %}
    {% if attachments %}
        <h2 class="h3 mt-6 mb-3">{% trans %}Files{% endtrans %}</h2>
        <table class="table">
            {% for attachment in attachments %}
                <tr>
                    <td><a href="{{ attachment.url }}" target="_blank">{{ attachment.title if attachment.title else attachment.product.name }} {% if attachment.file %}({{ (attachment.file.size / 1024 / 1024)|int }} MB){% endif %}</a></td>
                    <td>
                        {% if attachment.description %}
                            {{ attachment.description|linebreaksbr }}
                        {% endif %}
                    </td>
                </tr>
            {% endfor %}
        </table>
    {% endif %}
{% endmacro %}

{% macro render_lines_table(lines, taxful_total_price, taxless_total_price, show_product_package_info=False) %}
    <div class="list-group lines order-table">
        {% set show_supplier_info = xtheme.get("show_supplier_info") %}
        {% if xtheme.get("group_items_by_supplier") %}
            {% set groupped_lines = xtheme.group_lines_by_supplier(lines) %}
            {% for supplier, lines in groupped_lines.items() %}
                <div class="list-group-item supplier-info-item">
                    <div class="cells">
                        <div class="line-cell supplier-info-cell">
                            {%- if supplier -%}
                                {{- render_basket_supplier_info(supplier) -}}
                            {%- endif -%}
                        </div>
                    </div>
                </div>
                {% for line in lines %}
                    <div class="list-group-item">
                        <div class="cells">
                            {{ render_line(line, False) }}
                        </div>
                    </div>
                {% endfor %}
            {% endfor %}
        {% else %}
            {% for line in lines %}
                <div class="list-group-item">
                    <div class="cells">
                        {{ render_line(line, show_supplier_info) }}
                    </div>
                </div>
            {% endfor %}
        {% endif %}
        <div class="list-group-item">
            <div class="cells lines-summary">
                <div class="line-cell product-image hidden-sm hidden-xs"><label></label><div></div></div>
                <div class="line-cell text hidden-sm hidden-xs"><label></label><div></div></div>
                <div class="line-cell hidden-sm hidden-xs"><label></label><div></div></div>
                <div class="line-cell hidden-sm hidden-xs"><label></label><div></div></div>
                <div class="line-cell lines-total">
                    <div>
                        <strong>{% trans %}Total{% endtrans %}: {{ taxful_total_price|money }}</strong>
                        {% if taxless_total_price.amount != taxful_total_price.amount %}
                            <br>
                            <span class="total-price text-muted">({{ taxless_total_price|money }} {{ _("excl. tax") }})</span>
                        {% endif %}
                    </div>
                </div>
            </div>
        </div>
    </div>
{% endmacro %}

{% macro render_line(line, show_supplier_info=False) %}
    {% set product = line.product %}
    <div class="line-cell product-image{% if not product %} hidden-xs{% endif %}">
        <label></label>
        <div>
        {% if product %}
            {% set image = product.primary_image %}
            {% if not image and product.variation_parent %}
                {% set image = product.variation_parent.primary_image %}
            {% endif %}
            {% if image %}
                <img class="img-responsive" src="{{ image|thumbnail(size=(200, 200)) }}" alt="{{ line.text }}">
            {% else %}
                <img class="img-responsive" src="{{ STATIC_URL }}shuup/front/img/no_image_thumbnail.png">
            {% endif %}
        {% endif %}
        </div>
    </div>
    <div class="line-cell text">
        <label>{% if product %}{% trans %}Product{% endtrans %}{% else %}{{ line.type.label|title }}{% endif %}</label>
        <div>
            {{ line.text }}
            {% if show_supplier_info and line.supplier %}{{ render_supplier_info(line.supplier) }}{% endif %}
            {% if show_product_package_info and product and product.is_package_parent() %}
                {{ render_package_children(product) }}
            {% endif %}
        </div>
    </div>
    <div class="line-cell price">
        <label>{% trans %}Price{% endtrans %}</label>
        <div>
            {{ line.taxful_discounted_unit_price|money }}
            {% if line.tax_amount %}
                <br>
                <small class="text-muted">
                    ({{ line.taxless_discounted_unit_price|money }} {% trans %}excl. tax{% endtrans %})
                </small>
            {% endif %}
            {% if line.is_discounted %}
                <br>
                <small class="text-muted">
                    <del>{{ line.taxful_base_unit_price|money }}</del>
                </small>
            {% endif %}
        </div>
    </div>
    <div class="line-cell">
        <label>{% trans %}Quantity{% endtrans %}</label>
        <div>
        {{ line.quantity|number }}
        </div>
    </div>
    <div class="line-cell price">
        {% if show_prices() and not xtheme.get("hide_prices") %}
            <label>{% trans %}Total{% endtrans %}</label>
            <div>
                <span class="line-total">{{ line.taxful_price|money }}</span>
            </div>
        {% endif %}
    </div>
{% endmacro %}
